// File: ArrInit.cc

#include <ArrInit.h>
#include <ArrInitT.h>

int main()
{
                      // only public elements:
  PublicS PuS;        //   implicit default Constructor
  PuS.s = "";         //   aggregate initialization:
  PublicC PuC = {11, "111", 11.11}; 
                      // private elements:
                      //   no aggregate initialization:
// PrivateC PrC = {22, "222", 22.22};
//  `PrC' must be initialized by constructor, not by `{...}'

                      // constructor, but no implicit default:
// NoDefaultC NoDefC1;
//  no matching function for call to `NoDefaultC::NoDefaultC ()'
//  candidates are: NoDefaultC::NoDefaultC(const NoDefaultC &)
//                  NoDefaultC::NoDefaultC(int, char *, float)
                      //   no aggregate initialization:
// NoDefaultC NoDefC2 = {33, "333", 33.33};
//  `NoDefC2' must be initialized by constructor, not by `{...}'
                      //   constructor initialization:
  NoDefaultC NoDefC3(33, "333", 33.33);

                      // constructor, explicit default too:
// DefaultC DefC1 = {44, "444", 44.44};
//  `DefC1' must be initialized by constructor, not by `{...}'
  DefaultC DefC2;
  DefaultC DefC3(55, "555", 55.55);

  printOn(cout, PuS,     "PublicS");
  printOn(cout, PuC,     "PublicC");
  printOn(cout, NoDefC3, "NoDefaultC");
  printOn(cout, DefC2,   "DefaultC");
  printOn(cout, DefC3,   "DefaultC");
  cout << endl;

                      // only public elements:
  PublicS APuS[2];    //   implicit default Constructor
  APuS[0].s = ""; APuS[1].s = "";
                      //   aggregate initialization:
  PublicC APuC[] = {{66, "666", 66.66}, {77, "777", 77.77}};
                      // private elements:
                      //   no aggregate initialization:
// PrivateC APrC[] = {{88, "888", 88.88}, {99, "999", 99.99}};   
//  subobject of type `PrivateC' must be initialized by constructor,
//  not by `{88, "888", 0x00000000000000000000c00028f58f5cb1c24005}'
//  subobject of type `PrivateC' must be initialized by constructor,
//  not by `{99, "999", 0x000000000000000000007800ae14e147c7fa4005}'

                      // constructor, but no implicit default:
// NoDefaultC ANoDefC1[2];
// no matching function for call to `NoDefaultC::NoDefaultC ()'
// candidates are: NoDefaultC::NoDefaultC(const NoDefaultC &)
//                 NoDefaultC::NoDefaultC(int, char *, float)
                      //   no aggregate initialization:
// NoDefaultC ANoDefC2[] = {{10, "100", 10.10}, {11, "110", 11.11}};
//  subobject of type `NoDefaultC' must be initialized by constructor,
//  not by `{10, "100", 0x00000000000000000000980099999999a1994002}'
//  subobject of type `NoDefaultC' must be initialized by constructor,
//  not by `{11, "110", 0x00000000000000000000c00028f58f5cb1c24002}'
                      //   constructor initialization:
  NoDefaultC ANoDefC3[] = {NoDefaultC(12, "120", 12.12),
                           NoDefaultC(13, "130", 13.13)};
                      // constructor, explicit default too:
// DefaultC ADefC1[] = {{14, "140", 14.14}, {15, "150", 15.15}};
//  subobject of type `DefaultC' must be initialized by constructor,
//  not by `{14, "140", 0x000000000000000000004000d70a70a3e23d4002}'
//  subobject of type `DefaultC' must be initialized by constructor,
//  not by `{15, "150", 0x00000000000000000000680066666666f2664002}'

  DefaultC ADefC2[2];
  DefaultC ADefC3[] = {DefaultC(16, "160", 16.16),
                       DefaultC(17, "170", 17.17)};

  printOn(cout, APuS,      2, "PublicS");
  printOn(cout, APuC,      2, "PublicC");
  printOn(cout, ANoDefC3,  2, "NoDefaultC");
  printOn(cout, ADefC2,    2, "DefaultC");
  printOn(cout, ADefC3,    2, "DefaultC");

  return 0;
};
