// File: GeoObj.h

#ifndef GeoObj_h
#define GeoObj_h 1

#include <iostream.h>
#include <String.h>

class AbstractFactory;

class GeoObj 
{
private:
  AbstractFactory* pFactory;

protected:
  virtual int CompareTo(const GeoObj*) const = 0;

public:
  GeoObj(AbstractFactory* _pFactory = NULL)
  : pFactory(_pFactory){}
  virtual ~GeoObj(){};

  virtual GeoObj* Clone() const = 0;
  virtual float flaeche() const = 0;
  virtual String GetTypeString() const = 0;
  virtual void WriteOn(ostream&) const = 0;
  virtual void ReadFrom(istream&) = 0;

  AbstractFactory* SetFactory(AbstractFactory*);
  AbstractFactory* GetFactory();

friend int operator==(const GeoObj&, const GeoObj&);
friend int operator!=(const GeoObj&, const GeoObj&);

friend ostream& operator<<(ostream&, const GeoObj&);
friend istream& operator>>(istream&, GeoObj&);
};

inline AbstractFactory* GeoObj::SetFactory(AbstractFactory* _pFactory)
{
  AbstractFactory* pOld = pFactory;
  pFactory = _pFactory;
  return pOld;
}

inline AbstractFactory* GeoObj::GetFactory()
{
  return pFactory;
}

#endif
