// File: IOFactry.h

#ifndef IOFactory_h
#define IOFactory_h 1

#include <stl.h>
#include <String.h>
#include <bool.h>
#include <fstream.h>
#include <AbstFcry.h>

typedef less<String> StringCompare;
typedef map<String, GeoObj*, StringCompare> MapOfPrototypes;

class IOFactory : public AbstractFactory
{
private:
  MapOfPrototypes* pPrototypes;
  bool deleteStreams;
  istream* pIStream;
  ostream* pOStream;
  IOFactory(const IOFactory&);
  IOFactory& operator=(const IOFactory&);

public:
  IOFactory(MapOfPrototypes*);
  IOFactory(MapOfPrototypes*, istream*, ostream* = NULL);
  IOFactory(MapOfPrototypes*, const String&,
                              const String& = String(""));
  virtual ~IOFactory();
  virtual GeoObj* CreateGeoObj();
  virtual GeoObj* CreateGeoObj(const String&);
  virtual operator void*() const;
  virtual void CollectGeoObj(GeoObj*&);
};

#endif
