// File: MapIterT.h

#ifndef _MAPITERATORT_H_
#define _MAPITERATORT_H_
 
#include <iostream.h>
#include <bool.h>
#include <String.h>
#include <MapAssoT.h>

template<class K, class V>
class MapIterator
{
  typedef Assoc<K,V>* IMPLEMENTATION_TYPE;

private:
  IMPLEMENTATION_TYPE Impl;
  int Position;

public:
  MapIterator()
  : Impl(NULL), Position(0){}

  MapIterator(IMPLEMENTATION_TYPE _Impl, int _Index = 0)
  : Impl(_Impl), Position(_Index){}

  Assoc<K,V>& operator*()
  {
    return *(Impl + Position);
  }
  Assoc<K,V>& operator++()     // prefix
  {
    return *(Impl + ++Position);
  }
  Assoc<K,V>& operator++(int)  // postfix
  {
    return *(Impl + Position++);
  }
friend bool operator==(MapIterator&, MapIterator&);
friend bool operator!=(MapIterator&, MapIterator&);
};

template<class K, class V>
bool operator==(MapIterator<K,V>& I1, MapIterator<K,V>& I2)
{
  return ((I1.Impl == I2.Impl) && (I1.Position == I2.Position));
}
template<class K, class V>
bool operator!=(MapIterator<K,V>& I1, MapIterator<K,V>& I2)
{
  return !operator==(I1, I2);
}

#endif
