#ifndef _MAPT_H_
#define _MAPT_H_

#include <iostream.h>
#include <String.h>
#include <MapAssoT.h>
#include <MapIterT.h>

template<class K, class V>
class Map
{
  typedef Assoc<K,V>* IMPLEMENTATION_TYPE;

private:
  IMPLEMENTATION_TYPE Impl;
  V InitVal;
  int anzahl;
  int frei;

public:
  Map(V _InitVal, int = 16);
  ~Map();
  V& operator[](const K&);

  MapIterator<K,V> begin(){return MapIterator<K,V>(Impl, 0);}  
  MapIterator<K,V> end(){return MapIterator<K,V>(Impl, frei);}  
};

template<class K, class V>
Map<K,V>::Map(V _InitVal, int s)
: InitVal(_InitVal), anzahl(s < 1 ? 16: s), frei(0)
{
  Impl = new Assoc<K,V>[anzahl]; // setzt Defaultkonstruktor
}                                // fuer Assoc voraus
template<class K, class V>
Map<K,V>::~Map()
{
  delete[] Impl;
}
template<class K, class V>
V& Map<K,V>::operator[](const K& k1)
{
  IMPLEMENTATION_TYPE pp = Impl, qq;

  if(frei > 0)
  { // setzt Operator < fuer Key-Typ voraus:
    for(; (pp <= &Impl[frei - 1]) && (pp->Key < k1); pp++);

    if(pp < Impl + anzahl)
      if(k1 == pp->Key)
        return pp->Value;

// pp zeigt nun auf Pos., an der neuer Schluessel eingefuegt wird,
// hier muessen wir eine Luecke schaffen:
    if(frei < anzahl)
      for(qq = &Impl[frei - 1]; qq >= pp; qq--)
        *(qq + 1) = *qq;         // um eins nach hinten schieben
    else
    { 
      int i;

      IMPLEMENTATION_TYPE nImpl = new Assoc<K,V>[anzahl * 2];
      for(i = 0; i < (pp - Impl); i++)
        nImpl[i] = Impl[i];    // vorw. bis zur Luecke kop.
      for(i = anzahl - 1; i >= (pp - Impl); i--)
        nImpl[i + 1] = Impl[i];// rueckw. bis zur Luecke kop.
      pp = nImpl + (pp - Impl);
      delete[] Impl;
      Impl = nImpl;
      anzahl *= 2;
    }
  }
  frei++;
  pp->Key = k1;
  pp->Value = InitVal;
  return pp->Value;
}

#endif
