// File: NaivDrik.cc

#include <math.h>
#include <NaivDrik.h>

Dreieck::Dreieck(const Punkt& p0, const Punkt& p1, const Punkt& p2)
{
  EckPunkt[0] = p0;
  EckPunkt[1] = p1;
  EckPunkt[2] = p2;
}

Dreieck::Dreieck(const Dreieck &right)
{
  EckPunkt[0] = right.EckPunkt[0];
  EckPunkt[1] = right.EckPunkt[1];
  EckPunkt[2] = right.EckPunkt[2];
}

const Dreieck & Dreieck::operator=(const Dreieck &right)
{
  if(this != &right)
  {
    EckPunkt[0] = right.EckPunkt[0];
    EckPunkt[1] = right.EckPunkt[1];
    EckPunkt[2] = right.EckPunkt[2];
  }
  return *this;
}

float Dreieck::flaeche() const
{
  return (fabs(EckPunkt[0].x*(EckPunkt[1].y-EckPunkt[2].y)
             + EckPunkt[1].x*(EckPunkt[2].y-EckPunkt[0].y)
             + EckPunkt[2].x*(EckPunkt[0].y-EckPunkt[1].y)) / 2.0);
}

int Dreieck::CompareTo(const GeoObj* right) const
{
  if(right->GetTypeString() == GetTypeString())
  {
    const Dreieck* pr = (const Dreieck*)right;
    return ((EckPunkt[0] == pr->EckPunkt[0])
         && (EckPunkt[1] == pr->EckPunkt[1])
         && (EckPunkt[2] == pr->EckPunkt[2]));
  }
  else
    return 0;
}

void Dreieck::WriteOn(ostream& ros) const
{
  ros << " " << EckPunkt[0]
      << " " << EckPunkt[1]
      << " " << EckPunkt[2];
}

void Dreieck::ReadFrom(istream& ris)
{
   ris >> EckPunkt[0]
       >> EckPunkt[1]
       >> EckPunkt[2];
}

String Dreieck::GetTypeString() const
{
  return "[Dreieck]";
}
