// File: RchtckRV.cc

#include <RchtckRV.h>

const float RechteckRund::PI = 3.14159265389;

RechteckRund::RechteckRund(const Punkt& p0, const Punkt& p1, float _Radius)
: Rechteck(p0, p1), Radius(_Radius){}

RechteckRund::RechteckRund(const RechteckRund &right)
: Rechteck(right), Radius(right.Radius) {}

const RechteckRund& RechteckRund::operator=(const RechteckRund &right)
{ 
  if(this != &right)
  {
    Rechteck::operator=(right);
    Radius = right.Radius;  
  }

  return *this;
}

float RechteckRund::flaeche() const
{
  return (Rechteck::flaeche() - Radius * Radius * (4. - PI));
}
