// File: Rechteck.cc

#include <math.h>
#include <Rechteck.h>

Rechteck::Rechteck(const Punkt& p0, const Punkt& p1)
{
  EckPunkt[0] = p0;
  EckPunkt[1] = p1;
}

Rechteck::Rechteck(const Rechteck &right)
: GeoObj(right)
{
  EckPunkt[0] = right.EckPunkt[0];
  EckPunkt[1] = right.EckPunkt[1];
}

const Rechteck& Rechteck::operator=(const Rechteck &right)
{
   if(this != &right)
   { 
     GeoObj::operator=(right);
     EckPunkt[0] = right.EckPunkt[0];
     EckPunkt[1] = right.EckPunkt[1];
   }

   return *this;
}

GeoObj* Rechteck::Clone() const
{
  return new Rechteck(*this);
}

float Rechteck::flaeche() const
{
  return fabs((EckPunkt[0].x - EckPunkt[1].x) * (EckPunkt[0].y - EckPunkt[1].y));
}

int Rechteck::CompareTo(const GeoObj* right) const
{
  if(right->GetTypeString() == GetTypeString())
  {
    const Rechteck* pr = (const Rechteck*)right;
    return ((EckPunkt[0] == pr->EckPunkt[0])
         && (EckPunkt[1] == pr->EckPunkt[1]));
  }
  else
    return 0;
}

void Rechteck::WriteOn(ostream& ros) const
{
  ros << " " << EckPunkt[0]
      << " " << EckPunkt[1];
}

void Rechteck::ReadFrom(istream& ris)
{
   ris >> EckPunkt[0]
       >> EckPunkt[1];
}

String Rechteck::GetTypeString() const
{
  return "[Rechteck]";
}
