// File: ZGeoObj.cc

#include <ZGeoObj.h>

ZGeoObj::ZGeoObj(AbstractFactory* _pFactory)
: GeoObj(_pFactory), Count(0)
{
  for(int i = 0; i < MAX; i++)
    GeoObjs[i] = NULL;
}

ZGeoObj::ZGeoObj(const ZGeoObj &right)
: GeoObj(right)
{
// Copy Pointers:
  Count = right.Count;
  int i;
  for(i = 0; i < Count; i++)
    GeoObjs[i] = right.GeoObjs[i];
  for(; i < MAX; i++)
    GeoObjs[i] = NULL;
}

const ZGeoObj& ZGeoObj::operator=(const ZGeoObj &right)
{
  if(this != &right)
  {
    GeoObj::operator=(right);

//  Copy Pointers:
//  Vorsicht bei schon gespeicherten GeoObjs!
    Count = right.Count;
    int i;
    for(i = 0; i < Count; i++)
      GeoObjs[i] = right.GeoObjs[i];
    for(; i < MAX; i++)
      GeoObjs[i] = NULL;
  }
  return *this;
}

void ZGeoObj::Add(GeoObj& _GeoObj)
{
  if(Count < MAX)
    GeoObjs[Count++] = &_GeoObj;
}

GeoObj* ZGeoObj::Remove(GeoObj& _GeoObj)
{
  for(int i = 0; i < Count; i++)
    if(GeoObjs[i])
      if(*(GeoObjs[i]) == _GeoObj)
      {
        GeoObj* Tmp = GeoObjs[i];
        GeoObjs[i] = NULL;
  
        return Tmp;
      }
  return NULL;
}

GeoObj* ZGeoObj::GetGeoObj(int i)
{
  if(i < Count)
    return GeoObjs[i];
  else
    return NULL;
}

GeoObj* ZGeoObj::Clone() const
{
  return new ZGeoObj(*this);
}

float ZGeoObj::flaeche() const
{
   float fl = 0.0;
   for(int i = 0; i < Count; i++)
      if(GeoObjs[i])
        fl +=  GeoObjs[i]->flaeche();
   return fl;
}

int ZGeoObj::CompareTo(const GeoObj* right) const
{
  if(right->GetTypeString() == GetTypeString())
  {
    const ZGeoObj* pr = (const ZGeoObj*)right;
    if(Count != pr->Count)
      return 0;

    for(int i = 0; i < Count; i++)
      if(GeoObjs[i] && pr->GeoObjs[i])
      {
        if(*(GeoObjs[i]) != *(pr->GeoObjs[i]))
          return 0;
      }
      else
        if(GeoObjs[i] != pr->GeoObjs[i])
          return 0;

    return 1;
  }
  else
    return 0;
}

void ZGeoObj::WriteOn(ostream& ros) const
{
// Compacting...
  int i, nCount = 0;
  for(i = 0; i < Count; i++)
    if(GeoObjs[i])
      nCount++;

  ros << " " << nCount << endl;
  for(i = 0; i < Count; i++)
    if(GeoObjs[i])
    {
      ros << GeoObjs[i]->GetTypeString();
      GeoObjs[i]->WriteOn(ros);
      ros << endl;
    }
}

void ZGeoObj::ReadFrom(istream& ris)
{
// Das ist hoffentlich garantiert ein Syntaxfehler ;-) :
Praktikumsaufgabe ...
}

String ZGeoObj::GetTypeString() const
{
  return "[ZGeoObj]";
}
