// File: mGeoR.cc

#include <typeinfo>
#include <iostream.h>
#include <PunktR.h>
#include <PROTECT/RchteckR.h>
#include <PROTECT/RchtckRR.h>
#include <PROTECT/DreieckR.h>
#include <PROTECT/KreisR.h>
#include <PROTECT/ZGeoObjR.h>

int main()
{
   Rechteck r1(Punkt(0., 0.), Punkt(6., 5.));
   Rechteck r2(Punkt(6., 0.), Punkt(15., 5.));
   Dreieck   d(Punkt(0., 5.), Punkt(6., 5.), Punkt(3., 9.));
   ZGeoObj z1, z2;

  {  // Dieser Block erzeugt die Ausgabe wie im Teil 'A':
     cout << "Flaeche r1: " << r1.flaeche() << endl;
     cout << "Flaeche r2: " << r2.flaeche() << endl;
     cout << "Flaeche  d: " << d.flaeche() << endl;
     z1.Add(r1);
     z1.Add(d);
     cout << endl;
     cout << "Flaeche z1: " << z1.flaeche() << endl;
     z2.Add(z1);
     z2.Add(r2);
     cout << "Flaeche z2: " << z2.flaeche() << endl;

/* erwartete Ausgabe:
Flaeche r1: 30
Flaeche r2: 45
Flaeche  d: 12

Flaeche z1: 42
Flaeche z2: 87
*/
  }
  cout << "--------------" << endl;
  {  // Testen der Entfernen-Operation:
     GeoObj* pr1 = z1.GetGeoObj(0);
     if(*pr1 == r1)
       cout << "z1[0] ist Rechteck r1 mit Flaeche "
            << pr1->flaeche() << endl;

     z2.Add(*(z1.Remove(*pr1)));
     cout << "r1 aus z1 entfernt. Flaeche z1 jetzt: "
          << z1.flaeche() << endl;
     cout << "r1 zu z2 addiert. Flaeche z2 noch immer: "
          << z2.flaeche() << endl;
  }  
  {  // Testen der Typabfragen:
     GeoObj* pz1 = z2.GetGeoObj(0);
     if(*pz1 == z1)
       cout << "z2[0] ist ZGeoObj z1 mit Flaeche "
            << pz1->flaeche() << endl;

     if(typeid(*(z1.GetGeoObj(1))) == typeid(Dreieck))
       cout << "z1[1] ist ein Dreieck" << endl;
  }
  ZGeoObj nz2(z2);
  {  // Testen der Initialisierung/Zuweisung:
     cout << "neues ZGeoObj nz2 mit Flaeche "
          << nz2.flaeche() << endl;
     nz2 = z1;
     cout << "neues ZGeoObj nz2 jetzt mit Flaeche "
          << nz2.flaeche() << endl;

     nz2.Add(*(new Kreis(Punkt(3.0, 4.0), 10.0)));
     Kreis *pk = dynamic_cast<Kreis*>(nz2.GetGeoObj(2));

     if(pk)
       cout << "nz2[2] ist dynamischer Kreis mit Flaeche: "
            << pk->flaeche() << endl;
     cout << "Flaeche nz2 daher jetzt: " << nz2.flaeche() << endl;
     delete nz2.Remove(*pk);
     cout << "Kreis aus nz2 entfernt und geloescht. Flaeche wieder: "
          << nz2.flaeche() << endl;
  }
  {  // Testen der Downcasts:
     Dreieck *pd = dynamic_cast<Dreieck*>(nz2.GetGeoObj(1));
     if(pd)
       cout << "Downcast zu Dreieck erfolgreich." << endl;
     else
       cout << "Downcast zu Dreieck abgelehnt." << endl;

     Kreis *pk = dynamic_cast<Kreis*>(nz2.GetGeoObj(1));
     if(pk)
       cout << "Downcast zu Kreis erfolgreich." << endl;
     else
       cout << "Downcast zu Kreis abgelehnt." << endl;
  }
  {  // unendliche Rekursion:
     z1.Add(z2);
     cout << "Flaeche von z1: " << flush;
     cout << z1.flaeche() << endl;
  }
}
